//******************************************************************************
//!
//! @file $Id: mc_control.c 980 2008-03-27 09:59:50Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief (PID)
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ _______________________________________________________________
#include "config.h"
#include "mc_control.h"
#include "mc_interface.h"

#include "dac\dac_drv.h"

U8 duty_cycle = 0;					//!< vZPWMޭè قݒ肷Ұ
U8 regulation_type = OPEN_LOOP;		//!< `(OPEN_LOOP܂CLOSE_LOOP)`

/* xϐ */
S16 speed_error = 0;				//!< 덷vZ
S16 last_speed_error = 0;			//!< ŏI덷pϐ
S16 speed_integral = 0;
S16 speed_integ = 0;
S16 speed_proportional = 0;
S16 speed_derivative = 0;
S16 speed_der = 0;

/* dϐ */
S16 cur_error = 0;					//!< 덷vZ
S16 last_cur_error = 0;				//!< ŏI덷pϐ
S16 cur_integral = 0;
S16 cur_integ = 0;
S16 cur_proportional = 0;
S16 cur_derivative = 0;
S16 cur_der = 0;

/************************************************************************************************************/
/*												x													*/
/************************************************************************************************************/
/**
* @brief xɎgpAxJԂ
* KvҰ: config_motor.hKp_speed, Ki_speed, Kd_speed, K_speed_scal
* Te(ms)ł̌ĂяoKv
* @return x̒lA8ޯĂłޭè 
*/
U8 mc_control_speed(U8 speed_cmd)
{
  U8 Duty = 0;
  S32 increment = 0;

  // 덷vZ
  speed_error = speed_cmd - mci_get_measured_speed();	// l-255 <=> 255

  // ፀvZ
  speed_proportional = Kp_speed*speed_error;

  // ϕvZ
/*  speed_integral = speed_integral + speed_error;

  if(speed_integral >  255) speed_integral =  255;
  if(speed_integral < -255) speed_integral = -255;

  speed_integ = Ki_speed*speed_integral;
*/
  speed_integral = Ki_speed*(speed_integral + speed_error);

  if(speed_integral >  255) speed_integral =  255;
  if(speed_integral < -255) speed_integral = -255;

  // vZ
  /*speed_derivative = speed_error - last_speed_error;

  if(speed_derivative >  255) speed_derivative =  255;
  if(speed_derivative < -255) speed_derivative = -255;

  speed_der = Kd_speed*speed_derivative;

  last_speed_error = speed_error;*/

  // ޭè ٌvZ
  increment = speed_proportional + speed_integ;
  //increment += speed_der;
  increment = increment >> K_speed_scal;

  // ϐOa
  if(increment >= (S16)(255)) Duty = 255;
  else
  {
	if(increment <= (S16)(0)) Duty =   0;
	else Duty = (U8)(increment);
  }

  // ޭè قԂ
  return Duty;
}

/************************************************************************************************************/
/*												d													*/
/************************************************************************************************************/
/**
* @brief dɎgpAdJԂ
* KvҰ: config_motor.hKp_cur, Ki_cur, Kd_cur, K_cur_scal
* Te(ms)ł̌ĂяoKv
* @return d̒lA8ޯĂłޭè 
*/
U8 mc_control_current(U8 cur_cmd)
{
  U8 Duty = 0;
  S32 increment = 0;

  // 덷vZ
  cur_error = cur_cmd - (mci_get_measured_current());	// l-255 <=> 255

  // ፀvZ
  cur_proportional = Kp_cur*cur_error;

  // ϕvZ
  cur_integral = cur_integral + cur_error;

  if(cur_integral >  255) cur_integral =  255;
  if(cur_integral < -255) cur_integral = -255;

  cur_integ = Ki_cur*cur_integral;

  // vZ
  /*cur_derivative = cur_error - last_cur_error;

  if(cur_derivative >  255) cur_derivative =  255;
  if(cur_derivative < -255) cur_derivative = -255;

  cur_der = Kd_cur*cur_derivative;

  last_cur_error = cur_error;*/

  // ޭè ٌvZ
  increment = cur_proportional + cur_integ;
  //increment += cur_der;
  increment = increment >> K_cur_scal;

  // ϐOa
  if(increment >= (S16)(255)) Duty = 255;
  else
  {
	if(increment <= (S16)(0)) Duty =   0;
	else Duty = (U8)(increment);
  }

  // ޭè قԂ
  return Duty;
}

/******************************************************************************/
/*								JԂ̑I							  */
/******************************************************************************/

//! @brief xJn܂͒Ȃ
//! @post VPWMޭè 
void mc_regulation_loop()
{
  switch(regulation_type)
  {
	case OPEN_LOOP     : duty_cycle = mci_get_ref_speed();break;
	case SPEED_LOOP    : duty_cycle = mc_control_speed(2*mci_get_ref_speed());break;
	case CURRENT_LOOP  : duty_cycle = mc_control_current(mc_get_potentiometer_value());break;
	default : break;
  }
}


//! @brief ̌`ݒ
//! @post JHJԂݒ
void mc_set_open_loop(){regulation_type = OPEN_LOOP;}


//! @brief x`ݒ
void mc_set_speed_loop(){regulation_type = SPEED_LOOP;}


//! @brief d`ݒ
void mc_set_current_loop(){regulation_type = CURRENT_LOOP;}


//! @brief ޭè َ擾
U8 mc_get_duty_cycle()
{
  return duty_cycle;
}
